package org.topbraid.spin.arq;

import java.util.Iterator;

import com.hp.hpl.jena.sparql.syntax.TemplateGroup;
import com.hp.hpl.jena.sparql.syntax.TemplateTriple;
import com.hp.hpl.jena.sparql.syntax.TemplateVisitor;


/**
 * Base implementation of TemplateVisitor that calls visit for each triple
 * in a group.
 * 
 * @author Holger Knublauch
 */
public abstract class AbstractTemplateVisitor implements TemplateVisitor {

	public void visit(TemplateTriple triple) {
	}

	
	@SuppressWarnings("unchecked")
	public void visit(TemplateGroup group) {
		Iterator templates = group.templates();
		while(templates.hasNext()) {
			TemplateTriple t = (TemplateTriple) templates.next();
			t.visit(this);
		}
	}
}
