package org.topbraid.spin.constraints;

import java.util.Collection;

import com.hp.hpl.jena.rdf.model.Resource;


/**
 * An object representing a failure of a SPIN constraint.
 * 
 * @author Holger Knublauch
 */
public class ConstraintViolation {
	
	private String message;
	
	private Collection<SimplePropertyPath> paths;
	
	private Resource root;
	
	
	public ConstraintViolation(Resource root, Collection<SimplePropertyPath> paths, String message) {
		this.root = root;
		this.paths = paths;
		this.message = message;
	}
	
	
	public String getMessage() {
		return message;
	}
	
	
	public Collection<SimplePropertyPath> getPaths() {
		return paths;
	}
	

	public Resource getRoot() {
		return root;
	}
}
