package org.topbraid.spin.model;

import com.hp.hpl.jena.rdf.model.RDFNode;


/**
 * A LET assignment element.
 * 
 * @author Holger Knublauch
 */
public interface Let extends Element {
	
	/**
	 * Gets the SPARQL expression delivering the assigned value.
	 * @return the expression
	 */
	RDFNode getExpression();
	

	/**
	 * Gets the variable on the left hand side of the LET.
	 * @return the Variable
	 */
	Variable getVariable();
}
