package org.topbraid.spin.model.visitor;

import java.util.List;

import org.topbraid.spin.model.FunctionCall;
import org.topbraid.spin.model.Variable;

import com.hp.hpl.jena.rdf.model.RDFNode;


/**
 * An ExpressionVisitor that recursively visits all expressions under
 * a given root.
 * 
 * @author Holger Knublauch
 */
public class ExpressionWalker implements ExpressionVisitor {

	private ExpressionVisitor visitor;
	
	
	public ExpressionWalker(ExpressionVisitor visitor) {
		this.visitor = visitor;
	}

	
	public void visit(FunctionCall functionCall) {
		visitor.visit(functionCall);
		List<RDFNode> args = functionCall.getArguments();
		for(RDFNode arg : args) {
			ExpressionVisitors.visit(arg, this);
		}
	}

	
	public void visit(RDFNode node) {
		visitor.visit(node);
	}

	
	public void visit(Variable variable) {
		visitor.visit(variable);
	}
}
